package ru.landgrafhomyak.serdha.api.v0.misc

import ru.landgrafhomyak.serdha.api.v0.runtime.InputRow
import ru.landgrafhomyak.serdha.api.v0.runtime.OutputRow

public interface Expression<ExpressionUserExtension : Any> {
	public val userExtension: ExpressionUserExtension

	public interface RuntimeExpressionInput<RT, DT : DatabaseType<RT>, ExpressionUserExtension : Any> : Column<RT, DT, ExpressionUserExtension>
	public interface RuntimeExpressionOutput<RT, DT : DatabaseType<RT>, ExpressionUserExtension : Any> : QueryParam<RT, DT, ExpressionUserExtension>

	public fun interface InputLinker<ExpressionUserExtension : Any, QueryUserExtension : Any> {
		public fun link(linker: Scope<ExpressionUserExtension, QueryUserExtension>)

		public interface Scope<ExpressionUserExtension : Any, QueryUserExtension : Any> {
			public operator fun <RT, DT : DatabaseType<RT>> set(p: RuntimeExpressionInput<RT, DT, ExpressionUserExtension>, e: IntermediateColumn<RT, DT, QueryUserExtension>)
		}
	}

	public fun interface OutputLinker<ExpressionUserExtension : Any, QueryUserExtension : Any> {
		public fun link(linker: Scope<ExpressionUserExtension, QueryUserExtension>)

		public interface Scope<ExpressionUserExtension : Any, QueryUserExtension : Any> {
			public operator fun <RT, DT : DatabaseType<RT>> get(p: RuntimeExpressionOutput<RT, DT, ExpressionUserExtension>): IntermediateColumn<RT, DT, QueryUserExtension>
		}
	}

	public interface Creator<ExpressionUserExtension : Any> {
		public fun createExpression(creator: Scope<ExpressionUserExtension>): ExpressionUserExtension

		public interface Scope<ExpressionUserExtension : Any> {
			public fun <RT, DT : DatabaseType<RT>> input(name: String, type: DT): RuntimeExpressionInput<RT, DT, ExpressionUserExtension>
			public fun <RT, DT : DatabaseType<RT>> output(name: String, type: DT): RuntimeExpressionOutput<RT, DT, ExpressionUserExtension>
			public var action: Action<ExpressionUserExtension>
		}
	}

	public interface Action<ExpressionUserExtension : Any> {
		public fun calculate(input: OutputRow<ExpressionUserExtension>, output: InputRow<ExpressionUserExtension>)
	}
}