package ru.landgrafhomyak.serdha.api.v0.module

import ru.landgrafhomyak.serdha.api.v0.runtime.Transaction

public interface ModuleTemplate<@Suppress("unused") ModuleUserExtension : Any> {
	public interface Provider<UserExtension : Any> {
		public fun createModuleTemplates(scope: CreateModuleTemplatesScope): UserExtension
	}

	public interface CreateModuleTemplatesScope {
		public fun <NewModuleUserExtension : Any> createTemplate(
			versionKey: String,
			creator: ModuleCreator<NewModuleUserExtension>,
		): ModuleTemplate<NewModuleUserExtension>

		public fun <OldModuleUserExtension : Any, NewModuleUserExtension : Any> upgradeTemplate(
			versionKey: String,
			upgrade: ModuleUpgrade<OldModuleUserExtension, NewModuleUserExtension>,
		): ModuleTemplate<NewModuleUserExtension>
	}

	public interface ModuleCreator<ModuleUserExtension : Any> {
		public fun createSchema(rootNs: Namespace, creator: CreateModuleScope): ModuleUserExtension

		public suspend fun initData(ext: ModuleUserExtension, transaction: Transaction) {}
	}

	public interface ModuleUpgrade<OldModuleUserExtension : Any, NewModuleUserExtension : Any> {
		public fun upgradeSchema(oldModule: Module<OldModuleUserExtension>, rootNs: Namespace, upgrader: CreateModuleScope): NewModuleUserExtension

		public suspend fun upgradeData(ext: NewModuleUserExtension, transaction: Transaction) {}
	}

	public val versionKey: String
}