package ru.landgrafhomyak.serdha.api.v0.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.serdha.api.v0.misc.BuiltinExpressionsProvider
import ru.landgrafhomyak.serdha.api.v0.misc.Column
import ru.landgrafhomyak.serdha.api.v0.misc.IntermediateColumn
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.misc.Expression

public interface DefaultConstraint<TableUserExtension : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("name")
	public val name: String

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("table")
	public val table: Table<TableUserExtension, *>

	public interface Creator<ConstraintUserExtension : Any, RT, DT : DatabaseType<RT>, TargetTableUserExtension : Any> {
		public fun createCheckConstraint(scope: Scope<ConstraintUserExtension, RT, DT, TargetTableUserExtension>)

		public interface Scope<ConstraintUserExtension : Any, rRT, rDT : DatabaseType<rRT>, TargetTableUserExtension : Any> {
			public var result: IntermediateColumn<rRT, rDT, ConstraintUserExtension>
			public fun <RT, DT : DatabaseType<RT>> selectFromTargetTable(column: Column<RT, DT, TargetTableUserExtension>): IntermediateColumn<RT, DT, ConstraintUserExtension>

			public fun <ReferencedTableUserExtension : Any, RT, DT : DatabaseType<RT>> followReference(
				ref: IntermediateColumn<*, DatabaseType.ROW_ID<ReferencedTableUserExtension>, ConstraintUserExtension>,
				column: Column<RT, DT, ReferencedTableUserExtension>
			): IntermediateColumn<RT, DT, ReferencedTableUserExtension>

			public val builtinExpressions: BuiltinExpressionsProvider<ConstraintUserExtension>
			public fun <ExpressionUserExtension : Any> mapColumns(
				expression: Expression<ExpressionUserExtension>,
				input: Expression.InputLinker<ExpressionUserExtension, ConstraintUserExtension>,
				output: Expression.OutputLinker<ExpressionUserExtension, ConstraintUserExtension>
			)
		}
	}
}